unit TaskUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Dialogs, Forms, DateUtils,
  ShellAPI, ShlObj, IdHashCRC, IniFiles, FtGlobal, PathUnit, TaskScdl, iEPG;

const
  CPREFIX   = 'FriioTask';
  CRECDELAY = 10;
  CEXMARGIN = 3;
  CDATEFDEF = 'yyyymmdd';
  CPARAMVER = 3;

  CDATEFORMATS: array[0..4] of string = (
    {0}'yyyymmdd',
    {1}'yyyy-m-d',
    {2}'yyyy-mm-dd',
    {3}'yyyy"N"m""d""',
    {4}'yyyy"N"mm""d""'
  );

  CTASKWARNING = 
    'Windows ^XN Friio Task œKȏԂɒĂ܂B'#13#10#13#10 +
    'Windows ^XN Friio Task ̊֌W𐳂ĂȂꍇA'#13#10 +
    '^XN̐ݒ蓮ŕύXƘ^Ɏs邱Ƃ܂B';

type
  TTaskName = record
    Name: string;
    IsFriio: Boolean;
    TaskId: string;
  end;
  TTasks = array of TTaskName;

  TAfterFunc = (afNone, afSuspend, afHibern, afShutdown);

  TRecParam = record
    Version: Integer;
    Friio: Integer;
    StartDateTime: TDateTime;
    RecMinute: Integer;
    AfterFunc: TAfterFunc;
    Channel: string;
    TaskId: string;
    Title: string;
    DateFlg: Boolean;
    DateFormat: string;
  end;
  TRecParams = array of TRecParam;

  TFriioDevice = record
    Count: Byte;
    Dev: array[0..7] of Byte;
  end;

  TTaskOption = record
    ExecuteMargin: Integer;
    StartMargin: Integer;
    EndMargin: Integer;
    WakeUpFlg: Boolean;
    DeleteFlg: Boolean;
    AfterFunc: TAfterFunc;
    DateFlg: Boolean;
    DateFormat: string;
    MonitorFlg: Boolean;
    DummyFlg: Boolean;
    DummySize: Integer;
    FriioDevice: TFriioDevice;
  end;

  TFriioRecTask = record
    TaskName: string;
    RecParam: TRecParam;
    Station: string;
    WakeUpFlg: Boolean;
    DeleteFlg: Boolean;
    Enabled: Boolean;
  end;
  TFriioRecTasks = array of TFriioRecTask;

  TRecTaskReason = (rtrOverlap, rtrSConnect, rtrEConnect);
  TRecTaskReasons = set of TRecTaskReason;

  TRecTaskSearchResult = record
    RecTask: TFriioRecTask;
    Reasons: TRecTaskReasons;
    // Enabled: Boolean;
    IsNew: Boolean;
  end;
  TRecTaskSearchResults = array of TRecTaskSearchResult;

  TSearchStep = procedure;
  
// Windows ̃^XNtH_J (Vistap)
procedure OpenTasksFold;

// ^XNXPW[J(Vistap)
procedure OpneTaskScheduler;

// 20080311235959 t^ɕϊ
function TryStrToDateTimeEx(S: string; out DateTime: TDateTime): Boolean;
//  TAfterFunc ^ɕϊ
function TryStrToAfterFunc(S: string; out AfterFunc: TAfterFunc): Boolean;

// ttH[}bg Index 擾
function GetDateFormatIndex(S: string): Integer;

//  TRecParam ^ɕϊ
function TryStrToRecParam(S: string; out RecParam: TRecParam): Boolean;
// TRecParam ^𕶎ɕϊ
function RecParamToStr(RecParam: TRecParam): string;

// ^XNIvVǍ
function ReadTaskOption(AIni: TMemIniFile = nil): TTaskOption;
// Friio ̃foCX Index 쐬
function MakeFriioIndex(RecParam: TRecParam; TaskOption: TTaskOption): Integer;

// ^XN
function GetTaskList(out Tasks: TTasks): Boolean;
// ^^XN̏ڍׂ
function GetRecTaskList(Tasks: TTasks; out RecTasks: TFriioRecTasks): Boolean;
// ^^XNp[^
function GetRecParamList(Tasks: TTasks; out RecParams: TRecParams): Boolean;

// TFriioRecTasks ^JnԂŃ\[g
procedure SortRecTasks(var RecTasks: TFriioRecTasks);
// TRecParams ^JnԂŃ\[g
procedure SortRecParams(var RecParams: TRecParams);
// TRecTaskSearchResults ^JnԂŃ\[g
procedure SortRecTaskSearchResults(var RecTaskSearchResults: TRecTaskSearchResults);

// RecTask ƎԂdȂ^^XN RecTasks 猟ĕԂ
function SearchRecTask(RecTask: TFriioRecTask; RecTasks: TFriioRecTasks): TRecTaskSearchResults; overload;
function SearchRecTask(RecTask: TFriioRecTask; RecTasks: TFriioRecTasks; TaskOption: TTaskOption): TRecTaskSearchResults; overload;
// SearchResults w肵 SearchResult  Index Ԃ
function SearchResultsIndexOf(SearchResult: TRecTaskSearchResult; SearchResults: TRecTaskSearchResults): Integer; overload;
function SearchResultsIndexOf(TaskId: string; SearchResults: TRecTaskSearchResults): Integer; overload;
// SearchResults m
function CombinSearchResults(Res1, Res2: TRecTaskSearchResults): TRecTaskSearchResults;
// ^掞Ԃ̏d`FbN
function SearchOverlapTask(RecTasks: TFriioRecTasks; Step: TSearchStep): TRecTaskSearchResults; overload;
function SearchOverlapTask(RecTasks: TFriioRecTasks; Step: TSearchStep; TaskOption: TTaskOption): TRecTaskSearchResults; overload;
// dĂ^^XN
function AutoAdjustTask(Res: TRecTaskSearchResults; IsSilent: Boolean; Step: TSearchStep): Boolean; overload;
function AutoAdjustTask(Res: TRecTaskSearchResults; IsSilent: Boolean; Step: TSearchStep; TaskOption: TTaskOption): Boolean; overload;

// ݓ쒆Aw肵tȏォw肵ȓ̘^^XN
function SearchRecTime(DateTime: TDateTime; Min: Word): TFriioRecTasks;

// ^XNJ
function OpenTask(TaskName: string; out ErrMsg: string): TTask; overload;
function OpenTask(TaskName: string; out RecTask: TFriioRecTask; out ErrMsg: string): Boolean; overload;

// `l擾
function GetChannel(Station: string; out Channel: string): Boolean; overload;
function GetChannel(Station: string; IsSilent: Boolean; out Channel: string): Boolean; overload;
// ǖ擾
function GetStation(Channel: string): string;
// BS/CS̃`lRo[g
function ConvertChannel(Channel: string): string;

// ^XN쐬
function CreateTask(Username, Password: string; EpgData: TEpgData; out RecTask: TFriioRecTask; out ErrMsg: string): Boolean; overload;
function CreateTask(Username, Password: string; EpgData: TEpgData; IsSilent: Boolean; out RecTask: TFriioRecTask; out ErrMsg: string): Boolean; overload;

// ^XNJnԂvZĎ擾
function GetTaskDateTime(ADateTime: TDateTime; TaskOption: TTaskOption): TDateTime; overload;
function GetTaskDateTime(ADateTime: TDateTime): TDateTime; overload;
// ^XN㏑
function WriteTask(RecTask: TFriioRecTask; Username, Password: string; out Enabled: Boolean; out ErrMsg: string): Boolean;

implementation

// Windows ̃^XNtH_J
procedure OpenTasksFold;
var
  Filename: string;
  Command: string;
begin
  Filename  := 'Explorer';
  Command   := '/root,,::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{D6277990-4C6A-11CF-8D87-00AA0060F5BF}';
  ShellExecute(Application.Handle, 'OPEN', PChar(Filename), PChar(Command), '', SW_SHOW);
end;

// ^XNXPW[J(Vistap)
procedure OpneTaskScheduler;
var
  Filename: string;
  Command: string;
begin
  // %SystemRoot%\system32\taskschd.msc /s
  Filename  := GetSystemPath + 'taskschd.msc';
  Command   := '/s';
  ShellExecute(Application.Handle, 'OPEN', PChar(Filename), PChar(Command), '', SW_SHOW);
end;

// ^XNID擾
function GetTaskId(EpgData: TEpgData): string;
var
  S: string;
  Crc32: TIdHashCRC32;
  Data: TStringStream;
begin
(*
  // iEPG version 2 pōĂ̎c[
  Result  :=
    EpgData.Station +
    FormatDateTime('yyyymmdd', EpgData.StartDateTime) +
    EpgData.Id;
*)
  Result  := '';
(*
  v0.10ŎgĂ^XN ID p̌
  S :=
    EpgData.Station +
    FormatDateTime('yyyymmddhhnnss', EpgData.StartDateTime);
*)
  // v0.11 ō̗p ^XN ID p̌
  S :=
    EpgData.Station +
    FormatDateTime('yyyymmdd', EpgData.StartDateTime) +
    EpgData.Title;

  //  CRC32 `FbNT^XN ID Ƃ
  Crc32 := TIdHashCRC32.Create;
  Data  := TStringStream.Create(S);
  try
    Result  := IntToHex(Crc32.HashValue(Data), 8);
  finally
    Crc32.Free;
    Data.Free;
  end;
end;

// ^XN
function StrToTaskName(S: string): TTaskName;
var
  IdPos: Integer;
begin
  Result.Name    := S;
  Result.IsFriio := False;
  Result.TaskId  := '';
  if SameText(Copy(Result.Name, 1, Length(CPREFIX)), CPREFIX) then
  begin
    // FriioTask 쐬^XNۂ
    IdPos := AnsiPos('ID=', Result.Name);
    if IdPos > 0 then
    begin
      // FriioTask 쐬^XNƔF
      Result.IsFriio  := True;
      Result.TaskId   := Trim(Copy(Result.Name, IdPos + Length('ID='), MaxInt));
    end;
  end;
end;

// ^XN
function GetTaskList(out Tasks: TTasks): Boolean;
var
  Data: TStringList;
  i, n: Integer;
  TaskName: TTaskName;
begin
  Result  := False;
  SetLength(Tasks, 0);

  Data := TStringList.Create;
  try
    // ^XNꗗ擾
    try
      TaskGetTasks(Data);
      for i := 0 to Data.Count - 1 do
      begin
        TaskName := StrToTaskName(Data[i]);
        n := Length(Tasks);
        SetLength(Tasks, n + 1);
        Tasks[n]  := TaskName;
      end;
      Result  := True;
    except
    end;
  finally
    Data.Free;
  end;
end;

// ^^XN̏ڍׂ
function GetRecTaskList(Tasks: TTasks; out RecTasks: TFriioRecTasks): Boolean;
var
  i, n: Integer;
  RecTask: TFriioRecTask;
  ErrMsg: string;
begin
  Result  := False;
  SetLength(RecTasks, 0);

  try
    // Tasks ̒g
    for i := 0 to Length(Tasks) - 1 do
      if Tasks[i].IsFriio then
      begin
        if OpenTask(Tasks[i].Name, RecTask, ErrMsg) then
        begin
          // RecTasks ɒǉ
          n := Length(RecTasks);
          SetLength(RecTasks, n + 1);
          RecTasks[n] := RecTask;
        end;
      end;
    Result  := True;
  except
    on E: Exception do
      MessageDlg(Format('%s: %s', [E.ClassName, E.Message]), mtError, [mbOK], 0);
  end;
end;

// ^^XNp[^
function GetRecParamList(Tasks: TTasks; out RecParams: TRecParams): Boolean;
var
  i, n: Integer;
  RecTask: TFriioRecTask;
  ErrMsg: string;
begin
  Result  := False;
  SetLength(RecParams, 0);

  try
    // Tasks ̒g
    for i := 0 to Length(Tasks) - 1 do
      if Tasks[i].IsFriio then
      begin
        if OpenTask(Tasks[i].Name, RecTask, ErrMsg) then
        begin
          // RecParams ɒǉ
          n := Length(RecParams);
          SetLength(RecParams, n + 1);
          RecParams[n] := RecTask.RecParam;
        end;
      end;
    Result  := True;
  except
    on E: Exception do
      MessageDlg(Format('%s: %s', [E.ClassName, E.Message]), mtError, [mbOK], 0);
  end;
end;

// TFriioRecTasks ^JnԂŃ\[g
procedure SortRecTasks(var RecTasks: TFriioRecTasks);

  procedure QuickSort(L, R: Integer; var RecTasks: TFriioRecTasks);
  var
    I, J, P: Integer;
    Temp: TFriioRecTask;

    function DateTimeCompareEx(RecTasks: TFriioRecTasks;
      Index1, Index2: Integer): Integer;
    begin
      if RecTasks[Index1].RecParam.StartDateTime < RecTasks[Index2].RecParam.StartDateTime then
        Result := - 1
      else if RecTasks[Index1].RecParam.StartDateTime > RecTasks[Index2].RecParam.StartDateTime then
        Result := 1
      else
        Result := 0;
    end;
  begin
    repeat
      I := L;
      J := R;
      P := (L + R) shr 1;
      repeat
        while DateTimeCompareEx(RecTasks, I, P) < 0 do Inc(I);
        while DateTimeCompareEx(RecTasks, J, P) > 0 do Dec(J);
        if I <= J then
        begin
          //--------------------------------------------------------------------
          // RecTasks[I]  RecTasks[J] ւ鏈
          // begin
          Temp := RecTasks[I];
          RecTasks[I] := RecTasks[J];
          RecTasks[J] := Temp;
          // end;
          //--------------------------------------------------------------------
          if P = I then
            P := J
          else if P = J then
            P := I;
          Inc(I);
          Dec(J);
        end;
      until I > J;
      if L < J then QuickSort(L, J, RecTasks);
      L := I;
    until I >= R;
  end;
begin
  if Length(RecTasks) <> 0 then
  begin
    QuickSort(0, Length(RecTasks) - 1, RecTasks);
  end;
end;

// TRecParams ^JnԂŃ\[g
procedure SortRecParams(var RecParams: TRecParams);

  procedure QuickSort(L, R: Integer; var RecParams: TRecParams);
  var
    I, J, P: Integer;
    Temp: TRecParam;

    function DateTimeCompareEx(RecParams: TRecParams;
      Index1, Index2: Integer): Integer;
    begin
      if RecParams[Index1].StartDateTime < RecParams[Index2].StartDateTime then
        Result := - 1
      else if RecParams[Index1].StartDateTime > RecParams[Index2].StartDateTime then
        Result := 1
      else
        Result := 0;
    end;
  begin
    repeat
      I := L;
      J := R;
      P := (L + R) shr 1;
      repeat
        while DateTimeCompareEx(RecParams, I, P) < 0 do Inc(I);
        while DateTimeCompareEx(RecParams, J, P) > 0 do Dec(J);
        if I <= J then
        begin
          //--------------------------------------------------------------------
          // RecParams[I]  RecParams[J] ւ鏈
          // begin
          Temp := RecParams[I];
          RecParams[I] := RecParams[J];
          RecParams[J] := Temp;
          // end;
          //--------------------------------------------------------------------
          if P = I then
            P := J
          else if P = J then
            P := I;
          Inc(I);
          Dec(J);
        end;
      until I > J;
      if L < J then QuickSort(L, J, RecParams);
      L := I;
    until I >= R;
  end;
begin
  if Length(RecParams) <> 0 then
  begin
    QuickSort(0, Length(RecParams) - 1, RecParams);
  end;
end;

// TRecTaskSearchResults ^JnԂŃ\[g
procedure SortRecTaskSearchResults(var RecTaskSearchResults: TRecTaskSearchResults);

  procedure QuickSort(L, R: Integer; var RecTaskSearchResults: TRecTaskSearchResults);
  var
    I, J, P: Integer;
    Temp: TRecTaskSearchResult;

    function DateTimeCompareEx(RecTaskSearchResults: TRecTaskSearchResults;
      Index1, Index2: Integer): Integer;
    begin
      if
        RecTaskSearchResults[Index1].RecTask.RecParam.StartDateTime
        <
        RecTaskSearchResults[Index2].RecTask.RecParam.StartDateTime
        then
        Result := - 1
      else if
        RecTaskSearchResults[Index1].RecTask.RecParam.StartDateTime
        >
        RecTaskSearchResults[Index2].RecTask.RecParam.StartDateTime
        then
        Result := 1
      else
      begin
        // Result := 0;
        Result  := AnsiCompareText(
          RecTaskSearchResults[Index1].RecTask.RecParam.Title,
          RecTaskSearchResults[Index2].RecTask.RecParam.Title);
      end;
    end;
  begin
    repeat
      I := L;
      J := R;
      P := (L + R) shr 1;
      repeat
        while DateTimeCompareEx(RecTaskSearchResults, I, P) < 0 do Inc(I);
        while DateTimeCompareEx(RecTaskSearchResults, J, P) > 0 do Dec(J);
        if I <= J then
        begin
          //--------------------------------------------------------------------
          // RecTaskSearchResults[I]  RecTaskSearchResults[J] ւ鏈
          // begin
          Temp := RecTaskSearchResults[I];
          RecTaskSearchResults[I] := RecTaskSearchResults[J];
          RecTaskSearchResults[J] := Temp;
          // end;
          //--------------------------------------------------------------------
          if P = I then
            P := J
          else if P = J then
            P := I;
          Inc(I);
          Dec(J);
        end;
      until I > J;
      if L < J then QuickSort(L, J, RecTaskSearchResults);
      L := I;
    until I >= R;
  end;
begin
  if Length(RecTaskSearchResults) <> 0 then
  begin
    QuickSort(0, Length(RecTaskSearchResults) - 1, RecTaskSearchResults);
  end;
end;

function RecTaskCompare(const NowTask, ThenTask: TFriioRecTask): TRecTaskReasons;
type
  TDateTimeSpan = array[0..1] of TDateTime;
const
  CONNECT_SPAN_SEC = 30;
var
  NowDT: TDateTimeSpan;
  ThenDT: TDateTimeSpan;
  Intersect: TDateTimeSpan;
begin
  // l
  NowDT[0]  := NowTask.RecParam.StartDateTime;
  NowDT[1]  := IncMinute(NowTask.RecParam.StartDateTime, NowTask.RecParam.RecMinute);
  ThenDT[0] := ThenTask.RecParam.StartDateTime;
  ThenDT[1] := IncMinute(ThenTask.RecParam.StartDateTime, ThenTask.RecParam.RecMinute);

  // dԂ擾
  Intersect := NowDT;
  if ThenDT[0] > NowDT[0] then Intersect[0] := ThenDT[0];
  if ThenDT[1] < NowDT[1] then Intersect[1] := ThenDT[1];
  // dԃ`FbN
  Result  := [];
  if (Intersect[1] - Intersect[0]) > 0 then
    // dԂ
    Include(Result, rtrOverlap)
  else
    begin
      // dԂȂ
      if SecondsBetween(ThenDT[1], NowDT[0]) <= CONNECT_SPAN_SEC then
        // ThenTask ̏Iڑ
        Include(Result, rtrEConnect)
      else if SecondsBetween(NowDT[1], ThenDT[0]) <= CONNECT_SPAN_SEC then
        // ThenTask ̊Jnڑ
        Include(Result, rtrSConnect)
    end;
end;

// RecTask ƎԂdȂ^^XN RecTasks 猟ĕԂ
function SearchRecTask(RecTask: TFriioRecTask; RecTasks: TFriioRecTasks): TRecTaskSearchResults;
var
  TaskOption: TTaskOption;
begin
  // IvVǂݍ
  TaskOption  := ReadTaskOption;
  Result  := SearchRecTask(RecTask, RecTasks, TaskOption);
end;

// RecTask ƎԂdȂ^^XN RecTasks 猟ĕԂ
function SearchRecTask(RecTask: TFriioRecTask; RecTasks: TFriioRecTasks; TaskOption: TTaskOption): TRecTaskSearchResults;
var
  i, n: Integer;
  Res: TRecTaskReasons;
  IsOverlap, IsSConnect, IsEConnect: Boolean;
  FriioIndex: Integer;
begin
  // ߂l
  SetLength(Result, 0);

  // ϐ
  IsOverlap   := False;
  IsSConnect  := False;
  IsEConnect  := False;

  if RecTask.Enabled then
  begin
    // RecTask  Friio foCX Index 쐬
    FriioIndex  := MakeFriioIndex(RecTask.RecParam, TaskOption);

    // RecTasks [v
    for i := 0 to Length(RecTasks) - 1 do
    begin
      if
        // Lȃ^XN̂ݑΏ
        RecTasks[i].Enabled
        and
        // g͔Ώ
        (RecTask.RecParam.TaskId <> RecTasks[i].RecParam.TaskId)
        and
        // Friio foCX Index ^XN̂ݑΏ
        (FriioIndex = MakeFriioIndex(RecTasks[i].RecParam, ReadTaskOption))
        then
      begin
        Res := RecTaskCompare(RecTask, RecTasks[i]);
        if Res <> [] then
        begin
          // Result ɐVp[^ǉ
          n := Length(Result);
          SetLength(Result, n + 1);
          Result[n].RecTask := RecTasks[i];
          Result[n].Reasons := Res;
          //Result[n].Enabled := True;
          Result[n].IsNew   := False;
          if rtrOverlap in Res then IsOverlap := True;
          if rtrSConnect in Res then IsSConnect := True;
          if rtrEConnect in Res then IsEConnect := True;
        end;
      end;
    end;
  end;

  // gǉ
  i := Length(Result);
  if i > 0 then
  begin
    SetLength(Result, i + 1);
    Result[i].RecTask := RecTask;
    Result[i].Reasons := [];
    Result[i].IsNew   := False; //IsNew;
    if Result[i].RecTask.Enabled then
    begin
      if IsOverlap then Include(Result[i].Reasons, rtrOverlap);
      if IsSConnect then Include(Result[i].Reasons, rtrEConnect);
      if IsEConnect then Include(Result[i].Reasons, rtrSConnect);
    end;
  end;

  // ^JnԂŃ\[g
  SortRecTaskSearchResults(Result);
end;

// SearchResults w肵 SearchResult  Index Ԃ
function SearchResultsIndexOf(SearchResult: TRecTaskSearchResult;
  SearchResults: TRecTaskSearchResults): Integer;
var
  L: Integer;
begin
  Result  := - 1;
  for L := 0 to Length(SearchResults) - 1 do
    if SameText(SearchResult.RecTask.RecParam.TaskId, SearchResults[L].RecTask.RecParam.TaskId) then
    begin
      Result  := L;
      Break;
    end;
end;

// SearchResults w肵 SearchResult  Index Ԃ
function SearchResultsIndexOf(TaskId: string;
  SearchResults: TRecTaskSearchResults): Integer;
var
  L: Integer;
begin
  Result  := - 1;
  for L := 0 to Length(SearchResults) - 1 do
    if SameText(TaskId, SearchResults[L].RecTask.RecParam.TaskId) then
    begin
      Result  := L;
      Break;
    end;
end;

// SearchResults m
function CombinSearchResults(Res1, Res2: TRecTaskSearchResults): TRecTaskSearchResults;
var
  i, n, Index: Integer;
begin
  Result  := Res1;
  for i := 0 to Length(Res2) - 1 do
  begin
    Index := SearchResultsIndexOf(Res2[i], Result);
    if Index >= 0 then
    begin
      // Result[Index]Reason  Res2[i].Reason }[W
      Result[Index].Reasons := Result[Index].Reasons + Res2[i].Reasons
    end else
    begin
      // Result  Res2[i] ǉ
      n := Length(Result);
      SetLength(Result, n + 1);
      Result[n] := Res2[i];
    end;
  end;
  // ^JnԂŃ\[g
  SortRecTaskSearchResults(Result);
end;

// ^掞Ԃ̏d`FbN
function SearchOverlapTask(RecTasks: TFriioRecTasks; Step: TSearchStep): TRecTaskSearchResults;
var
  TaskOption: TTaskOption;
begin
  // IvVǂݍ
  TaskOption  := ReadTaskOption;
  Result  := SearchOverlapTask(RecTasks, Step, TaskOption);
end;

// ^掞Ԃ̏d`FbN
function SearchOverlapTask(RecTasks: TFriioRecTasks; Step: TSearchStep;
  TaskOption: TTaskOption): TRecTaskSearchResults; overload;
var
  i: Integer;
  Res: TRecTaskSearchResults;
begin
  // ߂l
  SetLength(Result, 0);
  SetLength(Res, 0);

  // \[g
  SortRecTasks(RecTasks);

  // [v
  for i := 0 to Length(RecTasks) - 1 do
  begin
    // d^XN
    Res := SearchRecTask(RecTasks[i], RecTasks, TaskOption);
    // ʂ
    if Length(Res) > 0 then
      Result := CombinSearchResults(Result, Res);
    if Assigned(Step) then Step;
  end;
end;

// dĂ^^XN
function AutoAdjustTask(Res: TRecTaskSearchResults; IsSilent: Boolean;
  Step: TSearchStep): Boolean;
var
  TaskOption: TTaskOption;
begin
  // IvVǂݍ
  TaskOption  := ReadTaskOption;
  Result  := AutoAdjustTask(Res, IsSilent, Step, TaskOption); 
end;

function AutoAdjustTask(Res: TRecTaskSearchResults; IsSilent: Boolean;
  Step: TSearchStep; TaskOption: TTaskOption): Boolean; overload;
const
  CMAX_STEP = 100;
var
  Username, Password: string;
  i, n, Count: Integer;
  AllNew: Boolean;
  AEnabled: Boolean;
  ErrMsg: string;
  Tasks: TTasks;
  RecTasks: TFriioRecTasks;
  NewTasks: array of string;
  FriioIndex: Integer;
  FriioType: Integer;
  NextFriioIndex: Integer;

  //  Friio ̃foCX Index Ԃ
  function GetNextFriioIndex(AFriioIndex: Integer; AFriioType: Integer): Integer;
  var
    L: Integer;
  begin
    Result  := - 1;
    // Friio ЂƂ̏ꍇ (AFriioIndex < 0) ͏I
    if AFriioIndex < 0 then Exit;
    // AFriioIndex ڑ Friio I
    if AFriioIndex >= TaskOption.FriioDevice.Count then Exit;

    for L := AFriioIndex + 1 to TaskOption.FriioDevice.Count - 1 do
      if AFriioType = TaskOption.FriioDevice.Dev[L] then
      begin
        //  Friio 
        Result  := L;
        Break;
      end;
  end;
begin
  Result  := True;

  // Tasks 
  if not GetTaskList(Tasks) then
  begin
    // Tasks ̏Ɏs
    if not IsSilent then
    begin
      MessageDlg(
        'Windows ^XN̈ꗗ擾Ɏs܂B'#13#10 +
        #13#10 +
        '^^XN̏d̎Ɏs܂B',
        mtError, [mbOK], 0);
    end;
    Result  := False;
    Exit;
  end;

  // NewTasks (TaskId z) 
  SetLength(NewTasks, 0);
  for i := 0 to Length(Res) - 1 do
    if Res[i].IsNew then
    begin
      // z TaskId ǉ
      n := Length(NewTasks);
      SetLength(NewTasks, n + 1);
      NewTasks[n] := Res[i].RecTask.RecParam.TaskId;
    end;
    
  // [U[ƃpX[h擾
  GetAccount(Username, Password);

  // [v
  Count  := 0;
  while Length(Res) > 0 do
  begin
    if Count >= CMAX_STEP then
    begin
      // [v̏ɒB
      if not IsSilent then
      begin
        MessageDlg(
          '^^XN̏d̎[vɒB܂B'#13#10 +
          #13#10 +
          '^^XN̏d̎Ɏs܂B',
          mtError, [mbOK], 0);
      end;
      Result  := False;
      Exit;
    end;

    AllNew  := True;
    for i := 0 to Length(Res) - 1 do
      if not Res[i].IsNew then
      begin
        AllNew  := False;
        // FriioIndex 쐬
        FriioIndex  := MakeFriioIndex(Res[i].RecTask.RecParam, TaskOption);
        // FriioType 𔻒f
        if Length(Res[i].RecTask.RecParam.Channel) > 2 then
          // 
          FriioType := 1
        else
          // 
          FriioType := 0;
        // NextFriioIndex 擾
        NextFriioIndex  := GetNextFriioIndex(FriioIndex, FriioType);

        // dȐ
        if rtrOverlap in Res[i].Reasons then
        begin
          // dĂ^XN
          if NextFriioIndex >= 0 then
            //  Friio 
            Res[i].RecTask.RecParam.Friio := NextFriioIndex
          else
            // 
            Res[i].RecTask.Enabled  := False;
        end
        else if rtrEConnect in Res[i].Reasons then
        begin
          // ڐG
          if NextFriioIndex >= 0 then
            //  Friio 
            Res[i].RecTask.RecParam.Friio := NextFriioIndex
          else
            // ^掞Ԃ1炷
            Res[i].RecTask.RecParam.RecMinute := Res[i].RecTask.RecParam.RecMinute - 1;
        end
        else if rtrSConnect in Res[i].Reasons then
        begin
          // OڐG
          if NextFriioIndex >= 0 then
            //  Friio 
            Res[i].RecTask.RecParam.Friio := NextFriioIndex
          else
            // ^JnԂ1₵Ę^掞Ԃ1炷
            Res[i].RecTask.RecParam.StartDateTime := IncMinute(Res[i].RecTask.RecParam.StartDateTime, 1);
            Res[i].RecTask.RecParam.RecMinute     := Res[i].RecTask.RecParam.RecMinute - 1;
        end;
        // ^XN㏑ۑ
        WriteTask(Res[i].RecTask, Username, Password, AEnabled, ErrMsg);
        // [vI
        Break;
      end;

    if AllNew then
      // d^XNׂĐVKǉȂ̂ŐVKǉC
      for i := 0 to Length(Res) - 1 do
      begin
        // FriioIndex 쐬
        FriioIndex  := MakeFriioIndex(Res[i].RecTask.RecParam, TaskOption);
        // FriioType 𔻒f
        if Length(Res[i].RecTask.RecParam.Channel) > 2 then
          // 
          FriioType := 1
        else
          // 
          FriioType := 0;
        // NextFriioIndex 擾
        NextFriioIndex  := GetNextFriioIndex(FriioIndex, FriioType);

        // dȐ
        if rtrOverlap in Res[i].Reasons then
        begin
          // dĂ^XN
          if NextFriioIndex >= 0 then
            //  Friio 
            Res[i].RecTask.RecParam.Friio := NextFriioIndex
          else
            // 
            Res[i].RecTask.Enabled  := False;
        end
        else if rtrEConnect in Res[i].Reasons then
        begin
          // ڐG
          if NextFriioIndex >= 0 then
            //  Friio 
            Res[i].RecTask.RecParam.Friio := NextFriioIndex
          else
            // ^掞Ԃ1炷
            Res[i].RecTask.RecParam.RecMinute := Res[i].RecTask.RecParam.RecMinute - 1;
        end
        else if rtrSConnect in Res[i].Reasons then
        begin
          // OڐG
          if NextFriioIndex >= 0 then
            //  Friio 
            Res[i].RecTask.RecParam.Friio := NextFriioIndex
          else
            // ^JnԂ1₵Ę^掞Ԃ1炷
            Res[i].RecTask.RecParam.StartDateTime := IncMinute(Res[i].RecTask.RecParam.StartDateTime, 1);
            Res[i].RecTask.RecParam.RecMinute     := Res[i].RecTask.RecParam.RecMinute - 1;
        end;
        // ^XN㏑ۑ
        WriteTask(Res[i].RecTask, Username, Password, AEnabled, ErrMsg);
        // [vI
        Break;
      end;

    // Res 
    SetLength(Res, 0);
    // ^^XNXgĎ擾
    if not GetRecTaskList(Tasks, RecTasks) then
    begin
      // ^^XNXg̎擾Ɏs
      if not IsSilent then
      begin
        MessageDlg(
          '^^XN̈ꗗ擾Ɏs܂B'#13#10 +
          #13#10 +
          '^^XN̏d̎Ɏs܂B',
          mtError, [mbOK], 0);
      end;
      Result  := False;
      Exit;
    end;
    Res := SearchOverlapTask(RecTasks, nil, TaskOption);

    // IsNew 𕜌
    for i := 0 to Length(NewTasks) - 1 do
    begin
      n := SearchResultsIndexOf(NewTasks[i], Res);
      if n >= 0 then Res[n].IsNew := True;
    end;

    // JEg
    Inc(Count);
    // Xebv
    if Assigned(Step) then Step;
  end;
end;

// ݓ쒆Aw肵tȏォw肵ȓ̘^^XN
function SearchRecTime(DateTime: TDateTime; Min: Word): TFriioRecTasks;
var
  Tasks: TTasks;
  RecTasks: TFriioRecTasks;
  i, n: Integer;
begin
  SetLength(Result, 0);

  if not GetTaskList(Tasks) then Exit;
  if not GetRecTaskList(Tasks, RecTasks) then Exit;

  for i := 0 to Length(RecTasks) - 1 do
  begin
    if RecTasks[i].Enabled then
      if
        // ^Jn݂̎ȍ~A݂̎ + Minȓ
        (RecTasks[i].RecParam.StartDateTime > DateTime)
        and
        (RecTasks[i].RecParam.StartDateTime < IncMinute(DateTime, Min))
        then
      begin
        n := Length(Result);
        SetLength(Result, n + 1);
        Result[n] := RecTasks[i];
      end;
  end;
end;

// ^XNJ
function OpenTask(TaskName: string; out ErrMsg: string): TTask;
var
  CheckName: TTaskName;
begin
  Result  := nil;
  
  // ^XNt@C`FbN
  if not TaskExists(TaskName) then
  begin
    // ^XNt@CȂ
    ErrMsg  := '^XNt@C܂B';
    Exit;
  end;

  CheckName := StrToTaskName(TaskName);
  if not CheckName.IsFriio then
  begin
    // FriioTask ̘^^XNł͂Ȃ
    ErrMsg  := 'Friio Task ̘^^XNł͂܂B';
    Exit;
  end;

  try
    Result  := TTask.Create(TaskName);
  except
    // \ʃG[
    on E: Exception do
    begin
      if Result <> nil then FreeAndNil(Result);
      ErrMsg  := Format('%s: %s', [E.ClassName, E.Message]);
    end;
  end;
end;

// ^XNJ
function OpenTask(TaskName: string; out RecTask: TFriioRecTask; out ErrMsg: string): Boolean;
var
  Task: TTask;
  Param: TStringList;
begin
  Result  := False;

  // ^XNJ
  Task  := OpenTask(TaskName, ErrMsg);
  if Task <> nil then
  begin
    Param := TStringList.Create;
    try
      try
        Param.CommaText := Task.Parameters;
        // p[^`FbN
        if Param.Count < 2 then
        begin
          // p[^z萔ȉȂ̂ŃG[I
          ErrMsg  := '^p[^słB';
          Exit;
        end;

        // p[^
        if not TryStrToRecParam(Param[1], RecTask.RecParam) then
        begin
          // ^p[^̉͂ɎŝŃG[I
          ErrMsg  := '^p[^słB';
          Exit;
        end;

        // ^XN
        RecTask.TaskName  := TaskName;

        // ǖ
        RecTask.Station   := GetStation(RecTask.RecParam.Channel);

        // X[v
        RecTask.WakeUpFlg := Task.Options.SystemRequired;
        // s^XN폜
        RecTask.DeleteFlg := Task.Options.DeleteWhenDone;

        // s
        RecTask.Enabled   := Task.Enabled;

        //
        Result  := True;
      except
        // \ʃG[
        on E: Exception do
        begin
          Result  := False;
          ErrMsg  := Format('%s: %s', [E.ClassName, E.Message]);
        end;
      end;
    finally
      Task.Free;
      Param.Free;
    end;
  end;
end;

// TaskName j[Nǂ`FbN
function IsUniqueTask(Tasks: TTasks; TaskName: TTaskName; out ExistName: string): Boolean;
var
  i: Integer;
begin
  Result    := True;
  ExistName := '';
  for i := 0 to Length(Tasks) - 1 do
  begin
    if AnsiSameText(Tasks[i].Name, TaskName.Name) then
    begin
      // TaskName ̓j[Nł͂Ȃ
      Result    := False;
      ExistName := Tasks[i].Name;
      Break;
    end
    else if (Tasks[i].IsFriio) and SameText(Tasks[i].TaskId, TaskName.TaskId) then
    begin
      // TaskName ̓j[Nł͂Ȃ
      Result    := False;
      ExistName := Tasks[i].Name;
      Break;
    end;
  end;
end;

// " Spɕϊ
function ConvTitle(S: string): string;
begin
  Result  := S;
  Result  := StringReplace(Result, '"', 'h', [rfReplaceAll]);
end;

// "  * ɕϊ
function EncodeFormat(S: string): string;
begin
  Result  := S;
  Result  := StringReplace(Result, '"', '*', [rfReplaceAll]);
end;

// *  " ɕϊ
function DecodeFormat(S: string): string;
begin
  Result  := S;
  Result  := StringReplace(Result, '*', '"', [rfReplaceAll]);
end;

//  TRecParam ^ɕϊ
function TryStrToRecParam(S: string; out RecParam: TRecParam): Boolean;
var
  Data: TStringArray;
begin
  Result  := False;

  // Version 1
  // 0|1             |2 |3|4 |5       |6             |7
  //  |start         |r |a|c |taskid  |title         |
  //  |20080311225959|20|1|21|C660D2B8|TVVbsO|

  // Version 2
  // 0|1|2             |3 |4|5 |6       |7|8       |9             |10
  //  |v|start         |r |a|c |taskid  |d|dformat |title         |
  //  |2|20080311225959|20|1|21|C660D2B8|1|yyyymmdd|TVVbsO|

  // Version 3 \
  // 0|1|2 |3             |4 |5|6 |7       |8|9       |10            |11
  //  |v|f |start         |r |a|c |taskid  |d|dformat |title         |
  //  |3|-1|20080311225959|20|1|21|C660D2B8|1|yyyymmdd|TVVbsO|


  Data  := Split('|', S);
  if Length(Data) > 7 then
  begin
    if SameText(Data[1], '3') then
    begin
      // Version 3
      if Length(Data) > 11 then
      begin
        RecParam.Version  := 3;
        // Friio
        if not TryStrToInt(Data[2], RecParam.Friio) then Exit;
        if (RecParam.Friio < - 1) or (RecParam.Friio > 7) then RecParam.Friio := - 1; 
        // Jn
        if not TryStrToDateTimeEx(Data[3], RecParam.StartDateTime) then Exit;
        // ^掞
        if not TryStrToInt(Data[4], RecParam.RecMinute) then Exit;
        // I㓮
        if not TryStrToAfterFunc(Data[5], RecParam.AfterFunc) then Exit;
        // `l
        RecParam.Channel    := Data[6];
        RecParam.TaskId     := Data[7];
        RecParam.DateFlg    := SameText(Data[8], '1');
        RecParam.DateFormat := DecodeFormat(Data[9]);
        RecParam.Title      := Data[10];
        Result  := True;
      end;
    end
    else if SameText(Data[1], '2') then
    begin
      // Version 2
      if Length(Data) > 10 then
      begin
        RecParam.Version  := 2;
        RecParam.Friio    := - 1;
        // Jn
        if not TryStrToDateTimeEx(Data[2], RecParam.StartDateTime) then Exit;
        // ^掞
        if not TryStrToInt(Data[3], RecParam.RecMinute) then Exit;
        // I㓮
        if not TryStrToAfterFunc(Data[4], RecParam.AfterFunc) then Exit;
        // `l
        RecParam.Channel    := Data[5];
        RecParam.TaskId     := Data[6];
        RecParam.DateFlg    := SameText(Data[7], '1');
        RecParam.DateFormat := DecodeFormat(Data[8]);
        RecParam.Title      := Data[9];
        Result  := True;
      end;
    end else
    begin 
      // Version 1
      RecParam.Version  := 1;
      RecParam.Friio    := - 1;
      // Jn
      if not TryStrToDateTimeEx(Data[1], RecParam.StartDateTime) then Exit;
      // ^掞
      if not TryStrToInt(Data[2], RecParam.RecMinute) then Exit;
      // I㓮
      if not TryStrToAfterFunc(Data[3], RecParam.AfterFunc) then Exit;
      // `l
      RecParam.Channel    := Data[4];
      RecParam.TaskId     := Data[5];
      RecParam.Title      := Data[6];
      RecParam.DateFlg    := False;
      RecParam.DateFormat := '';
      Result  := True;
    end;
  end;
end;

// TRecParam ^𕶎ɕϊ
function RecParamToStr(RecParam: TRecParam): string;

  function BoolToStr(B: Boolean): string;
  begin
    if B then Result := '1' else Result := '0';
  end;
begin
  case RecParam.Version of
  3:
    begin
      { Version 3 }
      // 0|1|2 |3             |4 |5|6 |7       |8|9       |10            |11
      //  |v|f |start         |r |a|c |taskid  |d|dformat |title         |
      //  |3|-1|20080311225959|20|1|21|C660D2B8|1|yyyymmdd|TVVbsO|
      Result  :=
        '|' +
        IntToStr(RecParam.Version) +
        '|' +
        IntToStr(RecParam.Friio) +
        '|' +
        FormatDateTime('yyyymmddhhnnss', RecParam.StartDateTime) +
        '|' +
        IntToStr(RecParam.RecMinute) +
        '|' +
        IntToStr(Integer(RecParam.AfterFunc)) +
        '|' +
        RecParam.Channel +
        '|' +
        RecParam.TaskId +
        '|' +
        BoolToStr(RecParam.DateFlg) +
        '|' +
        EncodeFormat(RecParam.DateFormat) +
        '|' +
        ConvTitle(RecParam.Title) +
        '|';
    end;
  2:
    begin
      { Version 2 }
      // 0|1|2             |3 |4|5 |6       |7|8       |9             |10
      //  |v|start         |r |a|c |taskid  |d|dformat |title         |
      //  |2|20080311225959|20|1|21|C660D2B8|1|yyyymmdd|TVVbsO|
      Result  :=
        '|' +
        IntToStr(RecParam.Version) +
        '|' +
        FormatDateTime('yyyymmddhhnnss', RecParam.StartDateTime) +
        '|' +
        IntToStr(RecParam.RecMinute) +
        '|' +
        IntToStr(Integer(RecParam.AfterFunc)) +
        '|' +
        RecParam.Channel +
        '|' +
        RecParam.TaskId +
        '|' +
        BoolToStr(RecParam.DateFlg) +
        '|' +
        EncodeFormat(RecParam.DateFormat) +
        '|' +
        ConvTitle(RecParam.Title) +
        '|';
    end;
  else
    begin
      { Versiong 1 }
      // 0|1             |2 |3|4 |5       |6             |7
      //  |start         |r |a|c |taskid  |title         |
      //  |20080311225959|20|1|21|C660D2B8|TVVbsO|
      Result  :=
        '|' +
        FormatDateTime('yyyymmddhhnnss', RecParam.StartDateTime) +
        '|' +
        IntToStr(RecParam.RecMinute) +
        '|' +
        IntToStr(Integer(RecParam.AfterFunc)) +
        '|' +
        RecParam.Channel +
        '|' +
        RecParam.TaskId +
        '|' +
        ConvTitle(RecParam.Title) +
        '|';
    end;
  end;
end;

// 20080311235959 t^ɕϊ
function TryStrToDateTimeEx(S: string; out DateTime: TDateTime): Boolean;
var
  Year, Mon, Day, Hour, Min, Sec: Integer;
begin
  Result  := False;
  Year  := StrToIntDef(Copy(S, 1,  4), - 1);
  if Year <= 0 then Exit;
  Mon   := StrToIntDef(Copy(S, 5,  2), - 1);
  if (Mon < 1) or (Mon > 12) then Exit;
  Day   := StrToIntDef(Copy(S, 7,  2), - 1);
  if (Day < 0) or (Mon > 31) then Exit;
  Hour  := StrToIntDef(Copy(S, 9,  2), - 1);
  if (Hour < 0) or (Hour > 23) then Exit;
  Min   := StrToIntDef(Copy(S, 11, 2), - 1);
  if (Min < 0) or (Min > 59) then Exit;
  Sec   := StrToIntDef(Copy(S, 13, 2), - 1);
  if (Sec < 0) or (Sec > 59) then Exit;

  Result  := TryEncodeDateTime(Year, Mon, Day, Hour, Min, Sec, 0, DateTime);
end;

//  TAfterFunc ^ɕϊ
function TryStrToAfterFunc(S: string; out AfterFunc: TAfterFunc): Boolean;
var
  IntFunc: Integer;
begin
  IntFunc := StrToIntDef(S, - 1);
  Result  := (IntFunc >= Integer(afNone)) and (IntFunc <= Integer(afShutdown));
  if Result then
    AfterFunc := TAfterFunc(IntFunc);
end;

// ttH[}bg Index 擾
function GetDateFormatIndex(S: string): Integer;
var
  i: Integer;
begin
  Result  := - 1;
  for i := 0 to Length(CDATEFORMATS) - 1 do
  begin
    if AnsiSameStr(S, CDATEFORMATS[i]) then
    begin
      Result  := i;
      Break;
    end;
  end;
end;

// ^XNt@Cl[
function RenameTaskFile(Src, Dest: string): Boolean;
begin
  // t@C쐬
  Src   := GetTasksPath + Format('%s.job', [Src]);
  Dest  := GetTasksPath + Format('%s.job', [Dest]);

  // t@Cړ
  Result:= MoveFile(PChar(Src), PChar(Dest));
end;

// ^XNIvVǍ
function ReadTaskOption(AIni: TMemIniFile = nil): TTaskOption;
var
  Ini: TMemIniFile;
  i, Temp: Integer;

  //   br
  // 1 = 傫
  // 0 = 
  // - 1 = b傫
  function CompareMinSec(Min, Sec: Integer): Integer;
  var
    MinTime: TDateTime;
    SecTime: TDateTime;
  begin
    MinTime := IncMinute(0, Min);
    SecTime := IncSecond(0, Sec);
    if MinTime > SecTime then
      Result := 1
    else if MinTime < SecTime then
      Result := - 1
    else
      Result := 0;
  end;
begin
  if AIni = nil then
    Ini := TMemIniFile.Create(ChangeFileExt(GetMainExeName, '.ini'))
  else
    Ini := AIni;
  try
    // N}[W
    Temp  := Ini.ReadInteger('Task', 'ExecuteMargin', CEXMARGIN);
    if Temp >= CEXMARGIN then
      Result.ExecuteMargin  := Temp
    else
      Result.ExecuteMargin  := CEXMARGIN;

    // ^Jn}[W
    Temp  := Ini.ReadInteger('Task', 'StartMargin', 10);
    if CompareMinSec(Result.ExecuteMargin, Temp + CRECDELAY) > 0 then
      Result.StartMargin  := Temp
    else
      Result.StartMargin  := 0;

    // ^I}[W
    Result.EndMargin  := Ini.ReadInteger('Task', 'EndMargin', 0);

    // tO
    Result.WakeUpFlg  := Ini.ReadBool('Task', 'WakeUpFlg', False);
    Result.DeleteFlg  := Ini.ReadBool('Task', 'DeleteFlg', False);

    // I㓮
    if not TryStrToAfterFunc(Ini.ReadString('Task', 'AfterFunc', '0'), Result.AfterFunc) then
    begin
      Result.AfterFunc  := afNone;
    end;

    // t
    Result.DateFlg    := Ini.ReadBool('Task', 'DateFlg', False);
    Result.DateFormat := Ini.ReadString('Task', 'DateFormat', CDATEFDEF);

    // j^[
    Result.MonitorFlg := Ini.ReadBool('Task', 'MonitorFlg', False);

    // _~[t@C
    Result.DummyFlg   := Ini.ReadBool('Task', 'DummyFlg', False);
    Temp              := Ini.ReadInteger('Task', 'DummySize', 1);
    if (Temp > 0) and (Temp <= 32767) then
      Result.DummySize  := Temp
    else
      Result.DummySize  := 1;

    // Friio 
    Temp := Ini.ReadInteger('Friio', 'Count', 1);
    // Friio  1 ` 8 ܂
    if Temp < 1 then Temp := 1;
    if Temp > 8 then Temp := 8;
    Result.FriioDevice.Count  := Byte(Temp);

    // Friio {̐ݒ
    for i := 0 to Length(Result.FriioDevice.Dev) - 1 do
    begin
      Temp  := Ini.ReadInteger('Friio', Format('Dev%d', [i]), 0);
      // Friio {̂ 0() ` 1() ܂
      if Temp < 0 then Temp := 0;
      if Temp > 1 then Temp := 1;
      Result.FriioDevice.Dev[i] := Byte(Temp);
    end;
  finally
    if AIni = nil then Ini.Free;
  end;
end;

// Friio ̃foCX Index 쐬
function MakeFriioIndex(RecParam: TRecParam; TaskOption: TTaskOption): Integer;
var
  i: Integer;
begin
  if TaskOption.FriioDevice.Count > 1 then
  begin
    // Friio ڑĂ
    Result  := RecParam.Friio;
    if
      // Friio I
      (Result < 0)
      or
      // IĂ Friio Ȃ
      (Result >= TaskOption.FriioDevice.Count)
      then
    begin
      // Friio I݂Ȃ̂ŁA
      // `lŒnfW or BS/CS 𔻒肵āA
      // ŏɌnfW or BS/CS p Friio I
      if Length(RecParam.Channel) > 2 then
      begin
        // BS/CS
        for i := 0 to TaskOption.FriioDevice.Count - 1 do
          if TaskOption.FriioDevice.Dev[i] = 1 then
          begin
            // 
            Result  := i;
            Break;
          end;
        if Result < 0 then
          // Ȃꍇ DEV0
          Result  := 0;
      end else
      begin
        // nfW
        for i := 0 to TaskOption.FriioDevice.Count - 1 do
          if TaskOption.FriioDevice.Dev[i] = 0 then
          begin
            // 
            Result  := i;
            Break;
          end;
        if Result < 0 then
          // Ȃꍇ DEV0
          Result  := 0;
      end;
    end;
  end else
  begin
    // Friio ͂ЂƂڑĂȂ
    Result  := - 1;
  end;
end;

// `l擾
function GetChannel(Station: string; out Channel: string): Boolean;
begin
  Result  := GetChannel(Station, False, Channel);
end;

function GetChannel(Station: string; IsSilent: Boolean;
  out Channel: string): Boolean; overload;
var
  Ini: TMemIniFile;
  ACaption, APrompt: string;
begin
  Result := False;

  Ini := TMemIniFile.Create(ChangeFileExt(GetMainExeName, '.ini'));
  try
    if Ini.ValueExists('Channel', Station) then
    begin
      // `lL[
      Channel := Ini.ReadString('Channel', Station, '');
      // Result  := True;
      // Exit;
    end;

    if Channel = '' then
    begin
      if not IsSilent then
      begin
        // Result = '' ̏ꍇ̓`lv
        ACaption := '`l̐ݒ';
        APrompt  := Format(
          'ǁu%sṽ`l͂ĂB'#13#10 +
          'nfW̏ꍇ 2̐lABS/CS ̏ꍇ bscs.ini ɏĂlA' +
          '10iɕϊl͂܂B'#13#10 +
          #13#10 +
          ': '#13#10 +
          '  tWer "21" '#13#10 +
          '  BStW "11958,40d1" A'#13#10 + 
          '  "783696081" ',
          [Station]);
        if InputQuery(ACaption, APrompt, Channel) then
        begin
          if Trim(Channel) <> '' then
          begin
            // `l̎擾
            Result := True;
            // `lRo[g
            Channel := ConvertChannel(Trim(Channel));
            Ini.WriteString('Channel', Station, Channel);
            Ini.UpdateFile;
          end;
        end;
      end;
    end else
      // `lԍ̎擾
      Result  := True;
  finally
    Ini.Free;
  end;
end;

// ǖ擾
function GetStation(Channel: string): string;
var
  Ini: TMemIniFile;
  Section: TStringList;
  i: Integer;
begin
  Result := '';

  Ini := TMemIniFile.Create(ChangeFileExt(GetMainExeName, '.ini'));
  Section := TStringList.Create;
  try
    Ini.ReadSection('Channel', Section);
    for i := 0 to Section.Count - 1 do
      if SameText(Ini.ReadString('Channel', Section[i], ''), Channel) then
      begin
        // `l擾ďI
        Result  := Section[i];
        Break;
      end;
  finally
    Ini.Free;
    Section.Free;
  end;
end;

// BS/CS̃`lRo[g
function ConvertChannel(Channel: string): string;
var
  Chs: TStringArray;
begin
  Result  := Channel;
  if Length(Result) > 2 then
  begin
    // 2傫珈
    Chs := Split(',', Channel);
    if Length(Chs) = 2 then
    begin
      // ',' ŕł珈
      Result  :=
        IntToHex(StrToIntDef(Chs[0], 0), 4) +
        IntToHex(StrToIntDef('$' + Chs[1], 0), 4);
      Result  := IntToStr(StrToIntDef('$' + Result, 0));
    end;
  end;
end;

// ^XN쐬
function CreateTask(Username, Password: string; EpgData: TEpgData;
  out RecTask: TFriioRecTask; out ErrMsg: string): Boolean;
begin
  Result  := CreateTask(Username, Password, EpgData, False, RecTask, ErrMsg);
end;

// ^XN쐬
function CreateTask(Username, Password: string; EpgData: TEpgData;
  IsSilent: Boolean;
  out RecTask: TFriioRecTask; out ErrMsg: string): Boolean; overload;
var
  TaskName: TTaskName;
  ExistName: string;
  Tasks: TTasks;
  Res: Integer;
  Channel: string;
  TaskOption: TTaskOption;
  RecParam: TRecParam;
  //DateStr: string;
  Task: TTask;
  Index: Integer;
  Trig: TTaskTriggerItem;
  TaskDateTime: TDateTime;
  RecNowFlgElapsedTime : integer; //^̂߂̏ 080423MύXbyBauer  ``
  RecNowFlgFileName : string;
  RecNowFlg : bool ;
  RecNowParamString : string ;    //^̂߂̏ 080423MύXbyBauer  `܂Ł`

  function GetTaskName(Title, TaskId: string): string;
  begin
    Result := StrToFilename(Format('FriioTask %s ID=%s', [Title, TaskId]));
  end;
  
  function MinuteSpanEx(const ANow, AThen: TDateTime): Integer;
  var
    Sec: Integer;
  begin
    Sec     := CeilEx(SecondSpan(ANow, AThen));
    Result  := Trunc(Sec / 60);
  end;
begin
  Result  := False;

  // TaskName 쐬
  TaskName.IsFriio  := True;
  TaskName.TaskId   := GetTaskId(EpgData);
  TaskName.Name     := GetTaskName(EpgData.Title, TaskName.TaskId);

  // ^XNꗗ擾
  if not GetTaskList(Tasks) then
  begin
    // ^XNꗗ̎擾Ɏs
    ErrMsg := '^XNꗗ̎擾Ɏs܂B'; 
    Exit;
  end;

  // j[N`FbN
  if not IsUniqueTask(Tasks, TaskName, ExistName) then
  begin
    // ̃^XN㏑
    if not IsSilent then
    begin
      if IsDialog('OverwriteTask') then
      begin
        Res := MessageDlg(
          'yFriio Taskz'#13#10 +
          Format('̘^^XNu%sv㏑܂B', [ExistName]) + #13#10#13#10 +
          '낵łH',
          mtConfirmation, [mbYes, mbNo], 0);
        if Res = mrYes then
        begin
          // ㏑I
          RenameTaskFile(ExistName, TaskName.Name);
        end else
        begin
          // ㏑ȂI
          ErrMsg := '[U[ɂ^XN쐬̒~B';
          Exit;
        end;
      end else
        // _CAO\Ȃŏ㏑
        RenameTaskFile(ExistName, TaskName.Name);
    end else
      // _CAO\Ȃŏ㏑
      RenameTaskFile(ExistName, TaskName.Name);
  end;

  // `lԍ擾
  if not GetChannel(EpgData.Station, IsSilent, Channel) then
  begin
    // `lԍ̐ݒLZ
    ErrMsg := '[U[ɂ^XN쐬̒~B';
    Exit;
  end;

  // ^XNIvV擾
  TaskOption  := ReadTaskOption;

  // p[^쐬
  RecParam.Version        := 3;   // V쐬^XN Version 3
  RecParam.Friio          := - 1; // Friio ͌ - 1 Œ
  RecParam.StartDateTime  := IncSecond(EpgData.StartDateTime, - (TaskOption.StartMargin + CRECDELAY));
  RecParam.RecMinute      := MinuteSpanEx(EpgData.StartDateTime, EpgData.EndDateTime) + TaskOption.EndMargin;
  RecParam.AfterFunc      := TaskOption.AfterFunc;
  RecParam.Channel        := Channel;
  RecParam.TaskId         := TaskName.TaskId;
  if EpgData.SubTitle = '' then
    // Tu^CgȂ
    RecParam.Title        := EpgData.Title
  else
    // Tu^Cgt̔ԑg
    RecParam.Title        := Format('%s ` %s', [EpgData.Title, EpgData.SubTitle]);
  // ^XNIvVttOݒ
  RecParam.DateFlg        := TaskOption.DateFlg;
  RecParam.DateFormat     := TaskOption.DateFormat;
(* v0.11b ܂ł̎c[
  if TaskOption.DateFlg then
  begin
    // ԑg^Cg̐擪ɓt
    try
      DateStr := FormatDateTime(TaskOption.DateFormat, EpgData.StartDateTime);
    except
      DateStr := FormatDateTime(CDATEFDEF, EpgData.StartDateTime);
    end;
    RecParam.Title  := Format('%s %s', [DateStr, RecParam.Title]);
  end;
*)
  // Friio foCX Index 쐬
  RecParam.Friio  := MakeFriioIndex(RecParam, TaskOption);

  // ^XNJnԂ쐬
  TaskDateTime  := IncMinute(EpgData.StartDateTime, - TaskOption.ExecuteMargin);

  //^̂߂̏ 080423MύXbyBauer@``
  RecNowFlg:=false;
  RecNowFlgFileName:= ExtractFilePath(Application.Exename) + '\RecNow.flg';
  if FileExists(RecNowFlgFileName) then
  begin
    //ُIRecNow.flgcĂɑzO̓Ȃ悤
    //t@C쐬oߕbŔ肵Rbȓł΍^ׂ̈̏s
    RecNowFlgElapsedTime:= Trunc(Now - FileDateToDateTime(FileAge(RecNowFlgFileName))) ;
    if RecNowFlgElapsedTime < 3 then
    begin
      RecNowFlg:=true;
      //^XNɓo^uFriioTask.exev̎s
      TaskDateTime  := EpgData.StartDateTime;
      RecNowParamString := Format('/r "%s"', [RecParamToStr(RecParam)]) ;
      //FriioTask.exes
      WinExec(PChar(GetMainExeNameEx + ' ' +RecNowParamString), 0);
    end;
    DeleteFile(RecNowFlgFileName);
  end;
  //if RecNowFlg=false then
  //^̂߂̏ 080423MύXbyBauer@`܂Ł`

  // ^XN쐬
  try
    Task  := TTask.Create(TaskName.Name, True);
    try
      Task.AppFileName    := GetMainExeNameEx;
      Task.Parameters     := Format('/r "%s"', [RecParamToStr(RecParam)]);
      Task.WorkDirectory  := GetAppDirNameEx;
      Task.Comment        := EpgData.Station + ' ' + RecParam.Title + #13#10 + EpgData.Text;

      // X[v
      Task.Options.SystemRequired := TaskOption.WakeUpFlg;
      // s^XN폜
      Task.Options.DeleteWhenDone := TaskOption.DeleteFlg;

      // ̑IvVݒ
      Task.Options.DontStartIfOnBatteries := False;
      Task.Options.KillIfGoingOnBatteries := False;
      Task.Options.KillOnIdleEnd          := False;
      Task.Options.RestartOnIdleResume    := False;
      Task.Options.StartOnlyIfIdle        := False;
      Task.Options.MaxRunTimeEnabled      := True;
      Task.Options.MaxRunTime             := 259200; // 72

      // XPW[
      if Task.Triggers.Count > 0 then
        // XPW[ݒ肪
        Index := 0
      else
        // XPW[ݒ肪Ȃ̂ō쐬
        Index := Task.Triggers.Add;

      Trig  := Task.Triggers.Item[Index];
      Trig.TriggerType  := ttOnce;
      Trig.BeginDate    := Trunc(TaskDateTime);
      Trig.StartHour    := HourOf(TaskDateTime);
      Trig.StartMinute  := MinuteOf(TaskDateTime);
      Trig.Disabled     := False;

      // AJEgݒ
      Task.SetAccount(Username, Password);

      // ^XNJn`FbN Enabled ݒ
      Task.Enabled  := TaskDateTime > Now;
      // Z[u
      Task.Save;
      
      // ^XNԂ
      RecTask.TaskName  := TaskName.Name;
      RecTask.RecParam  := RecParam;
      RecTask.Station   := EpgData.Station;
      RecTask.WakeUpFlg := TaskOption.WakeUpFlg;
      RecTask.DeleteFlg := TaskOption.DeleteFlg;
      RecTask.Enabled   := Task.Enabled; 
      // 
      Result    := True;
    finally
      Task.Free;
    end;
  except
    on E: Exception do
    begin
      Result  := False;
      ErrMsg  := Format('%s: %s', [E.ClassName, E.Message]);
    end;
  end;
end;

// ^XNJnԂvZĎ擾
function GetTaskDateTime(ADateTime: TDateTime; TaskOption: TTaskOption): TDateTime;
var
  Margin: Integer;
  Year, Mon, Day, Hour, Min, Sec, Mil: Word;
begin
  // ^}[Wb + CRECDELAY b𕪂ɕϊĎ擾
  Margin  := CeilEx((TaskOption.StartMargin + CRECDELAY) / 60);
  // ADateTime  Margin ǉ
  ADateTime  := IncMinute(ADateTime, Margin);
  // tevfɕ
  DecodeDateTime(ADateTime, Year, Mon, Day, Hour, Min, Sec, Mil);
  // bȉ؂̂ĂċN}[W}CiX
  Result  := IncMinute(EncodeDateTime(Year, Mon, Day, Hour, Min, 0, 0), - TaskOption.ExecuteMargin);
end;

function GetTaskDateTime(ADateTime: TDateTime): TDateTime;
var
  TaskOption: TTaskOption;
begin
  TaskOption  := ReadTaskOption;
  Result  := GetTaskDateTime(ADateTime, TaskOption);
end;

// ^XN㏑
function WriteTask(RecTask: TFriioRecTask; Username, Password: string; out Enabled: Boolean; out ErrMsg: string): Boolean;
var
  Task: TTask;
  RecParam: TRecParam;
  TaskOption: TTaskOption;
  Index: Integer;
  Trig: TTaskTriggerItem;
  TaskDateTime: TDateTime;
begin
  Result  := False;

  // ^XNJ
  Task  := OpenTask(RecTask.TaskName, ErrMsg);
  try
    if Task = nil then
    begin
      Exit;
    end;

    // ŏɃ^XNIvV擾
    TaskOption  := ReadTaskOption;

    // ϐɑ
    RecParam  := RecTask.RecParam;

    // ^XNJnԂ쐬
    TaskDateTime  := GetTaskDateTime(RecParam.StartDateTime, TaskOption);

    try
      // ^XN{
      Task.Parameters     := Format('/r "%s"', [RecParamToStr(RecParam)]);
      (**
       * tH_ʂɑΉ邽߁A㏑Ȃ (v0.31)
       * Task.AppFileName    := GetMainExeNameEx;
       * Task.WorkDirectory  := GetAppDirNameEx;
       *)
       
      // X[v
      Task.Options.SystemRequired := RecTask.WakeUpFlg;
      // s^XN폜
      Task.Options.DeleteWhenDone := RecTask.DeleteFlg;

      // XPW[
      if Task.Triggers.Count > 0 then
        // XPW[ݒ肪
        Index := 0
      else
        // XPW[ݒ肪Ȃ̂ō쐬
        Index := Task.Triggers.Add;

      (**
       * Windows ̃^XŃAs(ŏPʕ) + 20b܂ł
       * o^^XNsĂB
       * ( Windows 2000/XP )
       * :
       *   11Ɏs^XN1119bɓo^ = s
       *   11Ɏs^XN1120bɓo^ = sȂ
       *   ^XN̓o^ɐbĂ1119bɓo^Jn^XN͓o^ۂ
       *)
      Trig  := Task.Triggers.Item[Index];
      Trig.TriggerType  := ttOnce;
      Trig.BeginDate    := Trunc(TaskDateTime);
      Trig.StartHour    := HourOf(TaskDateTime);
      Trig.StartMinute  := MinuteOf(TaskDateTime);
      Trig.Disabled     := False;

      // ^XN̗L/
      Task.Enabled  := RecTask.Enabled;

      // AJEgݒ
      Task.SetAccount(Username, Password);

      // ^XNJnt`FbN
      Enabled := TaskDateTime > Now;
      if not Enabled then
        // sȂ^XNȂ̂Ŗ
        Task.Enabled  := False;
      // Z[u
      Task.Save;
      Result  := True;
    except
      on E: Exception do
      begin
        Result  := False;
        ErrMsg  := Format('%s: %s', [E.ClassName, E.Message]);
      end;
    end;
  finally
    if Task <> nil then Task.Free;
  end;
end;

end.
